#ifndef GL_SHARED_H
#define GL_SHARED_H

// singleton class for sharing simple OpenGL objects

#include <GL/glew.h>
#include <QPair>
#include <QHash>
#include <QVector>

class GLBufferObject;
class GLFramebufferObject;
class GLTextureRectangle;

// TODO: why can I get away with this now?
// uint qHash( QPair< int, int > key );

class GLShared
{
public:

	static GLShared* getInstance();
	static void destroy();
	
	GLFramebufferObject* getSharedFramebufferObject();

	// request count textures of size width by height
	QVector< GLTextureRectangle* > getSharedTexture( int width, int height, int count );

	// request a buffer object of size width by height
	GLBufferObject* getSharedXYCoordinateVBO( int width, int height );

private:

	GLShared();
	virtual ~GLShared();

	static GLShared* s_pSingleton;
	
	GLFramebufferObject* m_pFBO;

	QHash< QPair< int, int >, QVector< GLTextureRectangle* > > m_qhSharedTextures;
	QHash< QPair< int, int >, GLBufferObject* > m_qhSharedXYVBOs;
};

#endif
