#ifndef GL_UTILITIES_H
#define GL_UTILITIES_H

#include <GL/glew.h>

class GLProgram;
class GLShader;

class GLUtilities
{
public:

	static void setupOrthoCamera( int viewportWidth, int viewportHeight );

	// draw a screen aligned quad.  if zeroOneTextureCoordinates are true,
	// then the tex coordinates range from 0 to 1.  Otherwise, they will range
	// from 0 to width and 0 to height
	static void drawQuad( int width, int height, bool zeroOneTextureCoordinates = true, bool tTextureCoordinateZeroOnBottom = true );
	static void drawQuad( int x, int y, int width, int height, bool zeroOneTextureCoordinates = true, bool tTextureCoordinateZeroOnBottom = true );

	static float* readDepthBuffer( int x, int y, int width, int height );
	static void dumpDepthBufferText( int x, int y, int width, int height, const char* szFilename );
	static void dumpFrameBufferLuminanceText( int x, int y, int width, int height, const char* szFilename );
	static void dumpFrameBufferLuminanceBinary( int x, int y, int width, int height, const char* szFilename );
	static void dumpFrameBufferRGBABinary( int x, int y, int width, int height, const char* szFilename );	
	static void dumpFrameBufferRGBAText( int x, int y, int width, int height, const char* szFilename );	

	static void printGLRenderer();
	static void printGLVendor();
	static void printGLVersion();	
	static void printGLLastError();

private:

};

#endif
